#include "adc.h"
#include <avr/io.h>



/*********************************************************
*	name:	ADCInit
*	param: 	none
*	desc:	initializes a2d converter
*********************************************************/
void ADC_Init(void)
{
	ADMUX |= (1<<ADLAR); //only 8 bit
	ADCSRA |= (1<<ADEN) | (1<<ADPS2); //enable adc, prescaler 16
}

/*********************************************************
*	name:	ADCRead
*	param: 	channel - channel to read (1-4)
*	desc:	reads an analog channel
*********************************************************/
uint8_t ADC_Read(uint8_t channel)
{
	ADMUX &= ~((1<<MUX0) | (1<<MUX1));
	ADMUX |= channel; //select channel
	ADCSRA |= (1<<ADSC);//start conversion

	while(ADCSRA & (1<<ADSC))//wait
		asm volatile ("nop");

	return ADCH;
}

