#include "ring_buffer8.h"

void RingBuffer8_Push(RingBuffer8Data byte, struct SRingBuffer8 * ring_buffer)
{
	ring_buffer->data[ring_buffer->head] = byte;

	//keep pointer in valid memory
	if(ring_buffer->head < ring_buffer->size - 1)
		ring_buffer->head++;
    else
        ring_buffer->head = 0;
}

RingBuffer8Data RingBuffer8_Pop( struct SRingBuffer8 * ring_buffer)
{
	RingBuffer8Data byte = ring_buffer->data[ring_buffer->tail];

	//keep pointer in valid memory
	if(ring_buffer->tail < ring_buffer->size - 1)
		ring_buffer->tail++;
    else
        ring_buffer->tail = 0;

	return byte;
}

RingBuffer8Size	RingBuffer8_Size( struct SRingBuffer8 * ring_buffer)
{
    if(ring_buffer->head >= ring_buffer->tail)
        return ring_buffer->head - ring_buffer->tail;
    else
        return ring_buffer->size - ring_buffer->tail + ring_buffer->head;
}

void RingBuffer8_Clear( struct SRingBuffer8 * ring_buffer)
{
	ring_buffer->head = 0;
	ring_buffer->tail = 0;
}

void RingBuffer8_Init( struct SRingBuffer8 * ring_buffer, RingBuffer8Data * volatile data, RingBuffer8Size size)
{
	//set size to zero and init the 2 pointer
	ring_buffer->size = size;
	ring_buffer->data = data;
	ring_buffer->head = 0;
	ring_buffer->tail = 0;
}
