#include "spi.h"
#include <avr/io.h>


#define	DDR_SPI 	DDRB
#define PORT_SPI	PORTB
#define MOSI_PIN	3
#define SCK_PIN     5
#define MISO_PIN	4



void SPI_Init(void)
{
	PORT_SPI |= (1 << MISO_PIN); //miso pullup einschalten, damit eingang nicht floatet
	DDR_SPI |= (1 << MOSI_PIN) | (1 << SCK_PIN);

	SPI_Config( 0, 0 ); //not really needed, because the spi is configured every time we send data; but useful for debugging, because the spi hangs otherwise
}


uint8_t SPI_Transmit(uint8_t data)
{
	SPDR = data;
	while (!(SPSR & (1 << SPIF)));
	return SPDR;
}

void SPI_Config(uint8_t spcr, uint8_t spsr)
{
	SPCR = (spcr & (~(1 << SPIE))) | (1 << SPE) | (1 << MSTR);
	SPSR = spsr;
}

